//+------------------------------------------------------------------+
//|                                         Copyright 2015, SergDeev |
//|                                                http://fx-prog.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright 2015, SergDeev"
#property description "Universal Expert Advisor"
#property link      "http://fx-prog.ru"
#property icon      "\\Images\\uni.ico"
#property version   "1.3"
#property strict

//#resource "\\Indicators\\TestIndicator.ex4"

extern double startLot             = 0.2;
extern double maxLot               = 5;
extern double MaxRisk              = 2;
extern double Martin_factor        = 2;
extern int stepProfit              = 30;
extern double stepProfit_factor    = 0.5;
extern int stopLoss                = 30;
extern int takeProfit              = 100;
extern int noLoss                  = 30;
extern double noLoss_factor        = 0;
extern int trailStop               = 30;
extern int trailStep               = 2;
extern bool DualOrders             = false;
extern int maxOrders               = 5;

extern int MaPeriod           = 40;
extern ENUM_MA_METHOD MaMethod           = MODE_EMA;
extern ENUM_APPLIED_PRICE MaPrice            = PRICE_CLOSE;
extern int MaFilter           = 100;

extern bool useRsi            = true;
extern int RsiPeriod          = 14;
extern int RsiSignalLive      = 2;
extern ENUM_APPLIED_PRICE RsiPrice =PRICE_CLOSE;
extern bool useStoch          = true;
extern int StochK             = 5;
extern int StochD             = 3;
extern int StochSlow          = 3;
extern ENUM_STO_PRICE StochPrice  = STO_LOWHIGH;
extern ENUM_MA_METHOD StochMethod = MODE_SMA;
extern int StochSignalLive    = 2;

extern int ProfitNum               = 3;
extern double ProfitSumm           = 100.0;

string IndicatorName         = "::Indicators\\TestIndicator.ex4";
int openBuyBufferIndex       = 0; // openBuyBufferIndex (-1 to unused)
int takeProfitBuyBufferIndex = -1; // takeProfitBuyBufferIndex (-1 to unused)
int stopLossBuyBufferIndex   = -1; // stopLossBuyBufferIndex (-1 to unused)
int closeBuyBufferIndex      = -1; // closeBuyBufferIndex (-1 to unused)

int openSellBufferIndex      = 1; // openSellBufferIndex (-1 to unused)
int takeProfitSellBufferIndex = -1; // takeProfitSellBufferIndex (-1 to unused)
int stopLossSellBufferIndex   = -1; // stopLossSellBufferIndex (-1 to unused)
int closeSellBufferIndex     = -1; // closeSellBufferIndex (-1 to unused)
extern int BarIndex                 = 1; // BarIndex

extern int timeStart               = 0;
extern int timeEnd                 = 23;

extern int slippage                = 5;
extern int MAGIC                   = 20160308;

double lot_step;
int stop_level;

double min_lot,max_lot;
int step_profit_buy=0;
int step_profit_sell=0;
double noLossBuy,noLossSell;

int OnInit() {
/*
 if (!(IsDemo() || IsTesting())) {
   if (TimeHour(Time[0])>=2016 && TimeMonth(Time[0])>=4) {
    Alert("Demo time is end");
    return(INIT_FAILED);
   }
 }
*/ 
 min_lot = MarketInfo(NULL,MODE_MINLOT);
 max_lot = MarketInfo(NULL,MODE_MAXLOT);
 if (startLot < min_lot) startLot = min_lot;
 lot_step = MarketInfo(NULL,MODE_LOTSTEP);
 stop_level = (int)MarketInfo(NULL,MODE_STOPLEVEL);
 if (Digits == 5) {
  trailStop *= 10;
  trailStep *= 10;
  slippage *= 10;
  stepProfit *= 10;
  takeProfit *= 10;
  stopLoss *= 10;
  noLoss *= 10;
  MaFilter *= 10;
 }
 if (trailStop != 0 && trailStop < stop_level) trailStop = (int)(1.5*stop_level);
 if (stopLoss != 0 && stopLoss < stop_level) stopLoss = (int)(1.5*stop_level);
 if (takeProfit != 0 && takeProfit < stop_level) takeProfit = (int)(1.5*stop_level);
 
 if (BarIndex < 0) BarIndex = 0;

   ObjectCreate("Copyright",OBJ_LABEL,0,0,0);
   ObjectSet("Copyright",OBJPROP_CORNER,CORNER_LEFT_LOWER);
   ObjectSet("Copyright", OBJPROP_XSIZE, 160);
   ObjectSet("Copyright", OBJPROP_XDISTANCE, 10);
   ObjectSet("Copyright", OBJPROP_YDISTANCE, 10);
   ObjectSet("Copyright", OBJPROP_COLOR, clrGold);
   ObjectSet("Copyright", OBJPROP_SELECTABLE, false);
   ObjectSetText("Copyright","WWW.FX-PROG.RU");

 return(INIT_SUCCEEDED);
}
double NormalizeLots(double v) {
 if (maxLot > 0 && v > maxLot) v = maxLot;
 if (v > max_lot) v = max_lot;
 double x = NormalizeDouble((v/lot_step),0) * lot_step;
 if (x < min_lot) x = min_lot;
 return(x);
}
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason) {
 ObjectDelete(0,"Copyright");
}

bool Signal_Buy() {

 if (openBuyBufferIndex < 0) return(false);
 double x = iCustom(NULL,0,IndicatorName,openBuyBufferIndex,BarIndex);
 if (x != 0 && x != EMPTY_VALUE) return(true);

 return(false);
}

bool Signal_Sell() {

 if (openSellBufferIndex < 0) return(false);
 double x = iCustom(NULL,0,IndicatorName,openSellBufferIndex,BarIndex);
 if (x != 0 && x != EMPTY_VALUE) return(true);

 return(false);
}

bool Signal_Stop_Buy() {
 
 if (closeBuyBufferIndex < 0) return(false);
 double x = iCustom(NULL,0,IndicatorName,closeBuyBufferIndex,BarIndex);
 if (x != 0 && x != EMPTY_VALUE) return(true);

 return(false);
}
bool Signal_Stop_Sell() {

 if (closeSellBufferIndex < 0) return(false);
 double x = iCustom(NULL,0,IndicatorName,closeSellBufferIndex,BarIndex);
 if (x != 0 && x != EMPTY_VALUE) return(true);

 return(false);
}

void CheckForOpen(int mode) {
   static datetime lastBuy = 0;
   static datetime lastSell = 0;
   double SL,TP,lot,lx;
   
//   if (Volume[0] > 1) return;
   
   if ((mode==OP_BUY) && (lastBuy == 0 || lastBuy < Time[BarIndex]) && Signal_Buy()) {
    lastBuy = Time[BarIndex];
    TP = SL = 0;
    if (stopLossBuyBufferIndex > -1) SL = iCustom(NULL,0,IndicatorName,stopLossBuyBufferIndex,BarIndex);
    if (takeProfitBuyBufferIndex > -1) TP = iCustom(NULL,0,IndicatorName,takeProfitBuyBufferIndex,BarIndex);
    if ((SL == 0 || SL == EMPTY_VALUE) && stopLoss != 0) SL = Ask - stopLoss * Point;
    if ((TP == 0 || TP == EMPTY_VALUE) && takeProfit != 0) TP = Bid + takeProfit * Point;
    if (SL != 0 && (Bid-SL)/Point < MarketInfo(NULL,MODE_STOPLEVEL)) SL = Bid - 1.5 * MarketInfo(NULL,MODE_STOPLEVEL) * Point;
    if (TP != 0 && (TP-Ask)/Point < MarketInfo(NULL,MODE_STOPLEVEL)) TP = Ask + 1.5 * MarketInfo(NULL,MODE_STOPLEVEL) * Point;
    if (CheckProfitLast(lx) || Martin_factor <=0 ) {
     if ((MaxRisk > 0) && (SL != 0)) lot = (AccountFreeMargin()*MaxRisk/100)/((Ask-SL)/Point*MarketInfo(Symbol(),MODE_TICKVALUE));
     else lot = startLot;
    }
    else lot = lx * Martin_factor;
    lot = NormalizeLots(lot);
    if (AccountFreeMargin()<lot*MarketInfo(NULL,MODE_MARGINREQUIRED)) Print("No FreeMargin");
    else {
     if (SymbolInfoInteger(Symbol(),SYMBOL_TRADE_MODE) == SYMBOL_TRADE_EXECUTION_INSTANT) {
      if (OrderSend(Symbol(),OP_BUY,lot,Ask,slippage,NormalizeDouble(SL,Digits),NormalizeDouble(TP,Digits),MQLInfoString(MQL_PROGRAM_NAME),MAGIC,0,Blue)==-1)
      Print(__FUNCTION__," BUY_ORDER_SEND Ask:",Ask," SL:",SL," TP:",TP," lot:",lot,_LastError);
      else step_profit_buy = 1;
     }
     else {
      int x = OrderSend(Symbol(),OP_BUY,lot,Ask,slippage,0,0,MQLInfoString(MQL_PROGRAM_NAME),MAGIC,0,Blue);
      if (x == -1) Print(__FUNCTION__," BUY_ORDER_SEND Ask:",Ask," SL:",SL," TP:",TP," lot:",lot,_LastError);
      else {
       Sleep(1000);
       if (OrderSelect(x,SELECT_BY_TICKET)) {
        if (!OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(SL,Digits),NormalizeDouble(TP,Digits),0,Blue))  
        Print(__FUNCTION__," BUY_MODIFY_ERROR SL:",SL," TP:",TP," ",_LastError);
        else step_profit_buy = 1;
       } 
       else Print(__FUNCTION__," BUY_ORDER_SELECT_ERROR Ticket:",x," ",_LastError);
      }
     }
    }
   }

   if ((mode==OP_SELL) && (lastSell == 0 || lastSell < Time[BarIndex]) && Signal_Sell()) {
    lastSell = Time[BarIndex];
    TP = SL = 0;
    if (stopLossSellBufferIndex > -1) SL = iCustom(NULL,0,IndicatorName,stopLossSellBufferIndex,BarIndex);
    if (takeProfitSellBufferIndex > -1) TP = iCustom(NULL,0,IndicatorName,takeProfitSellBufferIndex,BarIndex);
    if ((SL == 0 || SL == EMPTY_VALUE) && stopLoss != 0) SL = Bid + stopLoss * Point;
    if ((TP == 0 || TP == EMPTY_VALUE) && takeProfit != 0) TP = Ask - takeProfit * Point;
    if (SL != 0 && (SL-Ask)/Point < MarketInfo(NULL,MODE_STOPLEVEL)) SL = Ask + 1.5 * MarketInfo(NULL,MODE_STOPLEVEL) * Point;
    if (TP != 0 && (Bid-TP)/Point < MarketInfo(NULL,MODE_STOPLEVEL)) TP = Bid - 1.5 * MarketInfo(NULL,MODE_STOPLEVEL) * Point;
    if (CheckProfitLast(lx) || Martin_factor <=0) {
     if ((MaxRisk > 0) && (SL != 0)) lot = (AccountFreeMargin()*MaxRisk/100)/((SL-Bid)/Point*MarketInfo(Symbol(),MODE_TICKVALUE));
     else lot = startLot;
    }
    else lot = lx * Martin_factor;
    lot = NormalizeLots(lot);
    if (AccountFreeMargin()<lot*MarketInfo(NULL,MODE_MARGINREQUIRED)) Print("No FreeMargin");
    else {
     if (SymbolInfoInteger(Symbol(),SYMBOL_TRADE_MODE) == SYMBOL_TRADE_EXECUTION_INSTANT) {
      if (OrderSend(Symbol(),OP_SELL,lot,Bid,slippage,NormalizeDouble(SL,Digits),NormalizeDouble(TP,Digits),MQLInfoString(MQL_PROGRAM_NAME),MAGIC,0,Red)==-1)
      Print(__FUNCTION__," SELL_ORDER_SEND Bid:",Bid," SL:",SL," TP:",TP," lot:",lot," ",_LastError);
      else step_profit_sell = 1;
     }
     else {
      int x = OrderSend(Symbol(),OP_SELL,lot,Bid,slippage,0,0,MQLInfoString(MQL_PROGRAM_NAME),MAGIC,0,Red);
      if (x == -1) Print(__FUNCTION__," SELL_ORDER_SEND Bid:",Bid," SL:",SL," TP:",TP," lot:",lot,_LastError);
      else {
       Sleep(1000);
       if (OrderSelect(x,SELECT_BY_TICKET)) {
        if (!OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(SL,Digits),NormalizeDouble(TP,Digits),0,Red))  
        Print(__FUNCTION__," SELL_MODIFY_ERROR SL:",SL," TP:",TP," ",_LastError);
        else step_profit_sell = 1;
       } 
       else Print(__FUNCTION__," SELL_ORDER_SELECT_ERROR Ticket:",x," ",_LastError);
      }
     }
    }
   }
}

//+------------------------------------------------------------------+
void CheckForClose() {
   double SL,x;
   
//   if (Volume[0] > 1) return;

   if (ProfitNum > 0 && ProfitSumm > 0)
   if (CalculateCurrentOrders(-1) >= ProfitNum)
   if (SummOrders(-1) >= ProfitSumm) {
    CloseAll();
    return;
   }
   
   for(int i=0;i<OrdersTotal();i++) {
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if ((OrderMagicNumber() != MAGIC) || (OrderSymbol() != Symbol())) continue;
      if (OrderType()==OP_BUY) {
        if (Signal_Stop_Buy()) {
         if (!OrderClose(OrderTicket(),OrderLots(),Ask,slippage,clrBlue))  Print(__FUNCTION__," BUY_STOP_ERROR price:",Ask," ",_LastError);
         else continue;
        }
        if (OrderStopLoss()<OrderOpenPrice()) {
         x = 0;
         if (noLoss_factor > 0) x = OrderOpenPrice() + noLoss_factor * (OrderOpenPrice()-OrderStopLoss());
         else if (noLoss > 0) x = OrderOpenPrice() + noLoss * Point;
         if (x != 0)
         if (Ask > x) {
          SL = OrderOpenPrice() + MarketInfo(NULL,MODE_SPREAD)*Point;
          SL = NormalizeDouble(SL,Digits);
          if (!OrderModify(OrderTicket(),OrderOpenPrice(),SL,OrderTakeProfit(),0)) Print(__FUNCTION__," BUY_NOLOSS_ERROR SL:",SL," ",_LastError);
         }
        }
        if (stepProfit_factor > 0) {
         x = OrderOpenPrice() + step_profit_buy * stepProfit * Point;
         if (Ask > x) {
          step_profit_buy++;
          if (!OrderClose(OrderTicket(),NormalizeLots(OrderLots()*stepProfit_factor),Ask,slippage,clrBlue)) Print(__FUNCTION__," BUY_STEP_PROFIT_ERROR LOT:",NormalizeLots(OrderLots()*stepProfit_factor)," ",_LastError);
          else continue;
         }
        }
        if ((trailStop > 0) && (OrderStopLoss() > OrderOpenPrice() || (noLoss <= 0 && noLoss_factor <=0))) {
         SL = NormalizeDouble((Bid-trailStop*Point),Digits);
         if (((SL-OrderStopLoss())/Point) > trailStep) {
          if (!OrderModify(OrderTicket(),OrderOpenPrice(),SL,OrderTakeProfit(),0)) Print(__FUNCTION__," BUY_TRAIL_STOP_ERROR SL:",SL," ",_LastError);
          else continue;
         }
        }
      }
      if (OrderType()==OP_SELL) {
        if (Signal_Stop_Sell()) {
         if (!OrderClose(OrderTicket(),OrderLots(),Bid,slippage,clrRed))  Print(__FUNCTION__," BUY_STOP_ERROR price:",Bid," ",_LastError);
         else continue;
        }
        if (OrderStopLoss()>OrderOpenPrice()) {
         x = 0;
         if (noLoss_factor > 0) x = OrderOpenPrice() - noLoss_factor * (OrderStopLoss()-OrderOpenPrice());
         else if (noLoss > 0) x = OrderOpenPrice() - noLoss * Point;
         if (x != 0)
         if (Bid < x) {
          SL = OrderOpenPrice() - MarketInfo(NULL,MODE_SPREAD)*Point;
          SL = NormalizeDouble(SL,Digits);
          if (!OrderModify(OrderTicket(),OrderOpenPrice(),SL,OrderTakeProfit(),0,clrRed)) Print(__FUNCTION__," SELL_NOLOSS_ERROR SL:",SL," ",_LastError);
         }
        }
        if (stepProfit_factor > 0) {
         x = OrderOpenPrice() - step_profit_sell * stepProfit * Point;
         if (Bid < x) {
          step_profit_sell++;
          if (!OrderClose(OrderTicket(),NormalizeLots(OrderLots()*stepProfit_factor),Bid,slippage,clrRed)) Print(__FUNCTION__," SELL_STEP_PROFIT_ERROR LOT:",NormalizeLots(OrderLots()*stepProfit_factor)," ",_LastError);
          else continue;
         }
        }
        if ((trailStop > 0) && (OrderStopLoss() < OrderOpenPrice() || (noLoss <= 0 && noLoss_factor <=0))) {
         SL = NormalizeDouble((Ask+trailStop*Point),Digits);
         if (((OrderStopLoss()-SL)/Point) > trailStep) {
          if (!OrderModify(OrderTicket(),OrderOpenPrice(),SL,OrderTakeProfit(),0,clrRed)) Print(__FUNCTION__," BUY_TRAIL_STOP_ERROR SL:",SL," ",_LastError);
          else continue;
         }
        }
      }
   }
}

bool CheckProfitLast(double &lot) {
 int num = OrdersHistoryTotal();
 for (int i=num-1; i>=0; i--) {
   if (OrderSelect(i,SELECT_BY_POS,MODE_HISTORY))
   if (OrderMagicNumber() == MAGIC)
   if (OrderCloseTime() != 0)
   if (OrderSymbol() == Symbol()) {
    lot = OrderLots();
    if (OrderProfit() >= 0) return(true);
    else return(false);
   }
 }
 return(true);
}

int CalculateCurrentOrders(int mode) {
   int num=0;
   for(int i=0;i<OrdersTotal();i++) {
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if (OrderMagicNumber() == MAGIC)
      if (OrderSymbol() == Symbol())
      if ((OrderType()==mode) || (mode==-1)) num++;
     }
   return(num);
}

void CloseAll() {
   for(int i=OrdersTotal();i>=0;i--) {
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
      if (OrderMagicNumber() >= MAGIC)
      if (OrderSymbol() == Symbol()) {
      if (OrderType() == OP_BUY) {
       if (!OrderClose(OrderTicket(),OrderLots(),Ask,slippage)) 
       Print(__FUNCTION__," ORDER_CLOSE:",OrderTicket()," error:",_LastError);
      }
      else if (OrderType() == OP_SELL) {
       if (!OrderClose(OrderTicket(),OrderLots(),Bid,slippage)) 
       Print(__FUNCTION__," ORDER_CLOSE:",OrderTicket()," error:",_LastError);
      }
      else if (!OrderDelete(OrderTicket())) Print(__FUNCTION__," ORDER_DELETE:",OrderTicket()," error:",_LastError);
      }
   }
}

double SummOrders(int mode) {
   double summ=0;
   for(int i=0;i<OrdersTotal();i++) {
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
      if (OrderMagicNumber() == MAGIC)
      if (OrderSymbol() == Symbol())
      if ((OrderType()==mode) || (mode==-1)) summ += OrderProfit() - OrderCommission() - OrderSwap() - OrderLots()*MarketInfo(NULL,MODE_SPREAD)*MarketInfo(NULL,MODE_TICKVALUE);
     }
   return(summ);
}

void OnTick() {
   if(Bars<100 || IsTradeAllowed()==false) return;
   if ((TimeHour(Time[0]) >= timeStart) && (TimeHour(Time[0]) <= timeEnd)) {
    if (DualOrders) {
      if (CalculateCurrentOrders(-1) < maxOrders) {
       CheckForOpen(OP_BUY); 
       CheckForOpen(OP_SELL);
     }
    }
    else {
      if (CalculateCurrentOrders(OP_BUY)==0 && CalculateCurrentOrders(OP_SELL) < maxOrders) CheckForOpen(OP_BUY);
      if (CalculateCurrentOrders(OP_SELL)==0 && CalculateCurrentOrders(OP_BUY) < maxOrders) CheckForOpen(OP_SELL);
    }
   }
   if (CalculateCurrentOrders(-1) > 0) CheckForClose();
//   Comment("\nProfit :",DoubleToString((AccountEquity()-AccountBalance()),2),"\nAccountBalance: ",DoubleToString(AccountBalance(),2),"\nAccountEquity: ",DoubleToString(AccountEquity(),2),"\nAccountMargin: ",DoubleToString(AccountMargin(),2),"\nAccountFreeMargin: ",DoubleToString(AccountFreeMargin(),2),"\nMargeenLevel: ",DoubleToString(AccountInfoDouble(ACCOUNT_MARGIN_LEVEL),2));
  }
//+------------------------------------------------------------------+
